import React from 'react';
import './index.css';
export interface AppTreeComponentProps {
    /** Title for ApplyTreeSelect. */
    /** 菜单选中后的回调函数. */
    selNode: Function;
    /** 默认传入的id值，用于回显应用树. */
    defaultAppId?: string | number;
    /** 应用树根节点类名，用于设置自定义样式. */
    className?: string;
    /** 是否禁用树选择 */
    disabled?: boolean;
    itemName: string;
}
declare const ApplyTreeSelect: React.FC<AppTreeComponentProps>;
export default ApplyTreeSelect;
