import React from 'react';
import './index.css';
export interface EchartLineComponentProps {
    /** 曲线图标题 */
    title: string;
    /** 图例的类型 */
    legendType: string;
    /** 头部标题栏 */
    options: string[] | number | [];
    /** x轴数据. */
    xdata: string | number | [];
    /** y轴数据,[[1,..],..]格式数据 */
    ydata?: string | number | [];
    /** 曲线是否平滑. */
    smooth?: boolean;
}
declare const EchartLineComponent: React.FC<EchartLineComponentProps>;
export default EchartLineComponent;
