/// <reference types="react" />
import './index.css';
interface MenuItem {
    label: string;
    key: string;
    icon?: string | React.ReactNode;
}
interface Item {
    label: string;
    key: string;
    icon?: string | React.ReactNode;
    children?: MenuItem[];
}
export interface FoldMenuComponentProps {
    /** 菜单数据，数组格式 */
    menus?: Item[];
    /**  */
    /** 菜单风格，可选light｜dark */
    theme: 'light' | 'dark';
    /** 菜单选中后的回调函数. */
    onSelMenu: (newValue: any) => void;
}
declare const FoldMenuComponent: React.FC<FoldMenuComponentProps>;
export default FoldMenuComponent;
