import React from 'react';
import './index.css';
export interface EchartBarMutiyComponentProps {
    /** 曲线图标题 */
    title: string;
    /** 标题分组栏，['分组1', '分组2', '分组3', '分组4']格式数据 */
    legend: string | number | [];
    /** x轴数据, ['test1', 'test2', 'test3','test4']格式数据*/
    xAxis: string | number | [];
    /** y轴数据,[{ name: 'test', type: "bar", data: [1,2]},..]格式数据 */
    series?: string | number | [];
    /** y轴参数,[{ type: 'value', name: "Evaporation",..]格式数据,详情参考echart*/
    yAxis?: string | number | [];
}
declare const EchartBarMutiyComponent: React.FC<EchartBarMutiyComponentProps>;
export default EchartBarMutiyComponent;
